from contextvars import ContextVar
from typing import Any

from propan.utils.classes import Singlethon


message = ContextVar("message", default=None)


class Context(Singlethon):
    _context: dict[str: Any] = {}

    def set_context(self, key: str, v: Any):
        self._context[key] = v

    def remove_context(self, key: str):
        self._context.pop(key, None)

    @property
    def context(self):
        return {
            **self._context,
            "context": self,
            "message": message.get()
        }


context = Context()
